"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const express_graphql_1 = require("express-graphql");
const Schema_1 = __importDefault(require("./Schema"));
const PORT = 4000;
const app = express_1.default();
app.use('/graphql', express_graphql_1.graphqlHTTP((req) => ({
    schema: Schema_1.default,
    graphiql: true,
    context: req,
})));
app.listen(PORT, () => {
    console.log(`App running on port ${PORT}`);
    console.log(`Open http://localhost:${PORT}/graphql`);
});
//# sourceMappingURL=app.js.map